// ------------------------------------------------------------------------------
// <auto-generated>
//    Generated by avrogen, version 1.9.0.0
//    Changes to this file may cause incorrect behavior and will be lost if code
//    is regenerated
// </auto-generated>
// ------------------------------------------------------------------------------

using System.Linq;

namespace io.axual.client.example.schema
{
	using System;
	using System.Collections.Generic;
	using System.Text;
	using Avro;
	using Avro.Specific;
	
	public partial class ApplicationLogEvent : ISpecificRecord
	{
		public static Schema _SCHEMA = Avro.Schema.Parse(@"{""type"":""record"",""name"":""ApplicationLogEvent"",""namespace"":""io.axual.client.example.schema"",""fields"":[{""name"":""timestamp"",""doc"":""Timestamp of the event"",""type"":""long""},{""name"":""source"",""doc"":""The application that sent the event"",""type"":{""type"":""record"",""name"":""Application"",""namespace"":""io.axual.client.example.schema"",""fields"":[{""name"":""name"",""doc"":""The name of the application"",""type"":""string""},{""name"":""version"",""doc"":""(Optional) The application version"",""default"":null,""type"":[""null"",""string""]},{""name"":""owner"",""doc"":""The owner of the application"",""default"":null,""type"":[""null"",""string""]}]}},{""name"":""context"",""doc"":""The application context, contains application-specific key-value pairs"",""type"":{""type"":""map"",""values"":""string""}},{""name"":""level"",""doc"":""The log level, being either DEBUG, INFO, WARN or ERROR"",""type"":{""type"":""enum"",""name"":""ApplicationLogLevel"",""namespace"":""io.axual.client.example.schema"",""symbols"":[""DEBUG"",""INFO"",""WARN"",""ERROR"",""FATAL""]}},{""name"":""message"",""doc"":""The log message"",""type"":""string""}]}");
		/// <summary>
		/// Timestamp of the event
		/// </summary>
		private long _timestamp;
		/// <summary>
		/// The application that sent the event
		/// </summary>
		private Application _source;
		/// <summary>
		/// The application context, contains application-specific key-value pairs
		/// </summary>
		private Dictionary<string, string> _context;
		/// <summary>
		/// The log level, being either DEBUG, INFO, WARN or ERROR
		/// </summary>
		private ApplicationLogLevel _level;
		/// <summary>
		/// The log message
		/// </summary>
		private string _message;
		public virtual Schema Schema
		{
			get
			{
				return ApplicationLogEvent._SCHEMA;
			}
		}
		/// <summary>
		/// Timestamp of the event
		/// </summary>
		public long timestamp
		{
			get
			{
				return this._timestamp;
			}
			set
			{
				this._timestamp = value;
			}
		}
		/// <summary>
		/// The application that sent the event
		/// </summary>
		public Application source
		{
			get
			{
				return this._source;
			}
			set
			{
				this._source = value;
			}
		}
		/// <summary>
		/// The application context, contains application-specific key-value pairs
		/// </summary>
		public Dictionary<string, string> context
		{
			get
			{
				return this._context;
			}
			set
			{
				this._context = value;
			}
		}
		/// <summary>
		/// The log level, being either DEBUG, INFO, WARN or ERROR
		/// </summary>
		public io.axual.client.example.schema.ApplicationLogLevel level
		{
			get
			{
				return this._level;
			}
			set
			{
				this._level = value;
			}
		}
		/// <summary>
		/// The log message
		/// </summary>
		public string message
		{
			get
			{
				return this._message;
			}
			set
			{
				this._message = value;
			}
		}
		public virtual object Get(int fieldPos)
		{
			switch (fieldPos)
			{
			case 0: return this.timestamp;
			case 1: return this.source;
			case 2: return this.context;
			case 3: return this.level;
			case 4: return this.message;
			default: throw new AvroRuntimeException("Bad index " + fieldPos + " in Get()");
			};
		}
		public virtual void Put(int fieldPos, object fieldValue)
		{
			switch (fieldPos)
			{
			case 0: this.timestamp = (System.Int64)fieldValue; break;
			case 1: this.source = (Application)fieldValue; break;
			case 2: this.context = (Dictionary<string, string>) fieldValue; break;
			case 3: this.level = (ApplicationLogLevel)fieldValue; break;
			case 4: this.message = (System.String)fieldValue; break;
			default: throw new AvroRuntimeException("Bad index " + fieldPos + " in Put()");
			};
		}
		
		public override string ToString()
		{
			var contextStr = string.Join(";", context.Select(x => x.Key + " = " + x.Value).ToArray());
			
			return $"[Application Log Event]: timestamp = {timestamp}, source = {{{source}}}, " +
			       $"context = {{{contextStr}}}, log level = {level}, message = {message} ";

		}
	}
}
